﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.OutlookBar;
using System.Windows.Controls.Primitives;
using System.Windows.Media.Imaging;
using C1.Silverlight;
using System.Windows.Markup;


namespace CustomOutlookBar
{
    public partial class MainPage
    {
        public MainPage()
        {
            InitializeComponent();       
            
        }
    }
    public class ExtendedOutlookBar : C1OutlookBar
    {

        public ExtendedOutlookBar()
        {
            DefaultStyleKey = typeof(ExtendedOutlookBar);
        }
    
      
        private bool _isopen = false;
        private UIElement Content { get; set; }
        private C1OutlookItem _lastselected;
        private int currentindex = -1;
        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            var bdr = GetTemplateChild("CollpasedStateBorder") as Border;
        
            var cp = GetTemplateChild("ContentPresenter") as ContentPresenter;

            var win = GetTemplateChild("CollapsedContentPopUp") as  C1Window;

            var btn = GetTemplateChild("ExpandButton") as Button;
            
           
            btn.Click += (s, e) =>
                {
                    if (this.IsExpanded == true)
                    {
                        if (win.Content != null)
                        {
                            Content = win.Content as UIElement;
                            win.Content = null;
                            _lastselected.Content = Content;
                            cp.Content = Content;
                        }
                        win.Visibility = Visibility.Collapsed;
                      
                        _isopen = false;
                        currentindex = -1;
                       
                    }
                   
                };
                
            this.SelectedItemChanged += (s, e) =>
                {
                   if((_isopen)  && (this.IsExpanded==false))
                   {
                     
                       if (_lastselected != null)
                       {
                           Content = win.Content as UIElement;
                           win.Content = null;
                           _lastselected.Content = Content;

                       }
                       currentindex = this.SelectedIndex; 
                       Content = (this.SelectedItem as C1OutlookItem).Content as UIElement; ;
                       (this.SelectedItem as C1OutlookItem).Content = null;
                       win.Content = Content;
                       _lastselected = this.SelectedItem as C1OutlookItem;
                   }
                };
            bdr.MouseLeftButtonDown += (s, e) =>
                {
                    if (this.IsExpanded == false)
                    {
                        if ((!_isopen) && (currentindex != this.SelectedIndex))
                        {

                            currentindex = this.SelectedIndex;
                            if ((_lastselected != null) && (_lastselected.Content == null))
                            {
                                Content = win.Content as UIElement;
                                win.Content = null;
                                _lastselected.Content = Content;

                            }

                            Content = (this.SelectedItem as C1OutlookItem).Content as UIElement; ;
                            (this.SelectedItem as C1OutlookItem).Content = null;

                            _lastselected = this.SelectedItem as C1OutlookItem;

                            win.Content = Content;
                            win.Visibility = Visibility.Visible;
                            _isopen = true;
                        }
                        else if ((_isopen == false) && (currentindex == this.SelectedIndex))
                        {
                            win.Visibility = Visibility.Visible;
                            _isopen = true;
                        }
                        else if (currentindex == this.SelectedIndex)
                        {
                            win.Visibility = Visibility.Collapsed;
                            _isopen = false;
                        }

                    }
                 
                };
        
        }
    }

}
